<?php

/*
 * (C) 2013-2016 iDorMobile LCC, telpho GmbH
 *
 * Version: 1.6.8
 *
 */

	require_once('includes/config.inc.php');

    $go_on = false;
	if (isset($_SESSION['user_level'])) {
		if (intval($_SESSION['user_level']) > 0) {
            $go_on = true;
        }
    }
    if (!$go_on) {
        header("Location: index.php");
		exit;
	}

    if (file_exists("temp/iDMCallLog.xlsx")) {
        exec("sudo rm temp/iDMCallLog.xlsx");
    }

    if (isset($_GET['action'])) {
        if ($_GET['action'] == "export_excel") {
            set_time_limit(300);
            $stmt = mysql_real_escape_string(htmlentities($_GET['stmt']));
            $stmt = substr($stmt,1);
            $stmt = substr($stmt,0,strlen($stmt)-1);
            if (excel_export($stmt)) {
                $filename = "temp/iDMCallLog.xlsx";
                $filename_temp = "iDMCallLog.xlsx";
                header("Content-Type: application/xlsx");
                header("Content-Disposition: attachment; filename='iDMCallLog.xlsx'");
                ob_clean();
                readfile($filename);
                unlink($filename);
                exit;
            }
        }
    }

	$items = array();
    $items_list = array();
    $apartment_selected = "all";
    $apartment_id = "0";

	$index = 0;

    if (intval($_SESSION['user_level']) >= 10) {
        $stmt = "Select number,name from apartments order by number";
        if ($s = mysql_query($stmt)) {
            while ($r = mysql_fetch_array($s)) {
                $items_list[] = $r;
            }
            mysql_free_result($s);
        }
        if (isset($_POST['apartment'])) {
            $apartment_selected = mysql_real_escape_string($_POST['apartment']);
        }
        if ($apartment_selected == "all") {
            $stmt = "Select * from calls order by datetime DESC LIMIT 1000";
        } else {
            $stmt = "Select id from apartments where number='".$apartment_selected."' LIMIT 1000";
            if ($s = mysql_query($stmt)) {
                if ($r = mysql_fetch_object($s)) {
                    $apartment_id = $r->id;
                }
            }
            $stmt = "Select * from calls where apartment_id='".$apartment_id."' order by datetime DESC LIMIT 1000";
        }
    } else {
        $stmt = "Select * from calls where apartment_id='".$_SESSION['apartment_id']."' order by datetime DESC LIMIT 1000";
    }

    if ($s = mysql_query($stmt)) {
		while ($r = mysql_fetch_array($s)) {
			$index++;
            $t = $r['datetime'];
            $d = substr($t,4,2)."/".substr($t,6,2)."/".substr($t,0,4)." ".substr($t,8,2).":".substr($t,10,2);
            $r['datetime'] = $d;
            if (intval($r['answered']) == "0") {
                $r['answered'] = "no";
            } else {
                $r['answered'] = "yes";
            }
			$r['_index'] = $index;
			$items[$index] = $r;
		}
		mysql_free_result($s);
	}


    $o_smarty->assign('stmt',$stmt);

    $o_smarty->assign('items',$items);
    $o_smarty->assign('items_list',$items_list);
    $o_smarty->assign('apartment_selected',$apartment_selected);

	$o_smarty->assign('system_info',$_SESSION['system_info']);
	$o_smarty->assign("user_level",$_SESSION['user_level']);
	$content = $o_smarty->fetch('calls.html');
	$o_smarty->assign('content',$content);
	$o_smarty->display('index.html');



function excel_export($stmt) {

    require_once('Classes/PHPExcel.php');

    $excel = new PHPExcel();

    $excel->getProperties()->setCreator("iDorMobile GUI");
    $excel->getProperties()->setLastModifiedBy("iDorMobile GUI");
    $excel->getProperties()->setTitle("iDorMobile Call Log");
    $excel->getProperties()->setSubject("iDorMobile Call Log");
    $excel->getProperties()->setDescription("Export of Call Log");

    // store all apartments in first sheet
    $excel->setActiveSheetIndex(0);
    $excel->getActiveSheet()->setTitle("Call Log");
    $excel->getActiveSheet()->setCellValue('A1', "Date");
    $excel->getActiveSheet()->setCellValue('B1', "Time");
    $excel->getActiveSheet()->setCellValue('C1', "Caller");
    $excel->getActiveSheet()->setCellValue('D1', "Caller Name");
    $excel->getActiveSheet()->setCellValue('E1', "Called");
    $excel->getActiveSheet()->setCellValue('F1', "Called Name");
    $excel->getActiveSheet()->setCellValue('G1', "Answered");
    $excel->getActiveSheet()->setCellValue('H1', "Answered By");
    foreach(range('A','H') as $columnID) {
        $excel->getActiveSheet()->getColumnDimension($columnID)
            ->setAutoSize(true);
    }

    $excel->setActiveSheetIndex(0);
    $row = 2;

    if ($s = mysql_query($stmt)) {
        while ($r = mysql_fetch_object($s)) {

            $d = substr($r->datetime,4,2)."/".substr($r->datetime,6,2)."/".substr($r->datetime,0,4);
            $excel->getActiveSheet()->setCellValue("A" . $row, $d);

            $t = substr($r->datetime,8,2).":".substr($r->datetime,10,2);
            $excel->getActiveSheet()->setCellValue("B" . $row, $t);

            $excel->getActiveSheet()->setCellValue("C" . $row, $r->caller);
            $excel->getActiveSheet()->setCellValue("D" . $row, $r->caller_name);
            $excel->getActiveSheet()->setCellValue("E" . $row, $r->called);
            $excel->getActiveSheet()->setCellValue("F" . $row, $r->called_name);

            if ($r->answered != "0") {
                $excel->getActiveSheet()->setCellValue("G" . $row, "yes");
            } else {
                $excel->getActiveSheet()->setCellValue("G" . $row, "no");
            }

            $excel->getActiveSheet()->setCellValue("H" . $row, $r->answered_name);

            $row++;
        }
        mysql_free_result($s);
    }

    $excel->setActiveSheetIndex(0);

    $writer = PHPExcel_IOFactory::createWriter($excel, "Excel2007");
    $filename = "temp/iDMCallLog.xlsx";
    $writer->save($filename);

    $excel = NULL;

    return true;
}

?>
